'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactMarkdown = require('react-markdown');

var _reactMarkdown2 = _interopRequireDefault(_reactMarkdown);

var _objectAssign = require('object-assign');

var _objectAssign2 = _interopRequireDefault(_objectAssign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MDEditor = function (_React$Component) {
  _inherits(MDEditor, _React$Component);

  function MDEditor(props) {
    _classCallCheck(this, MDEditor);

    var _this = _possibleConstructorReturn(this, (MDEditor.__proto__ || Object.getPrototypeOf(MDEditor)).call(this, props));

    _this.setCaretPosition = function (caretPos) {
      var textarea = _this.refs.text;
      if (textarea !== null) {
        if (textarea.createTextRange) {
          var range = textarea.createTextRange();
          range.move('character', caretPos);
          range.select();
        } else {
          if (textarea.selectionStart) {
            textarea.focus();
            textarea.setSelectionRange(caretPos, caretPos);
          } else {
            textarea.focus();
          }
        }
      }
    };

    _this.getSelection = function (value) {
      var cursorIndexStart = _this.refs.text.selectionStart;
      var cursorIndexEnd = _this.refs.text.selectionEnd;
      var selection = value.substring(cursorIndexStart, cursorIndexEnd);
      return {
        cursorIndexStart: cursorIndexStart,
        cursorIndexEnd: cursorIndexEnd,
        selection: selection
      };
    };

    _this.insertAtCursor = function (e, markdownLeftOrLR, right, _selection, markdownRight, cursorPosOffset) {
      if (e) {
        e.preventDefault();
      }
      var value = _this.props.value;
      var selectionProps = _this.getSelection(value);
      var cursorIndexStart = selectionProps.cursorIndexStart;
      var cursorIndexEnd = selectionProps.cursorIndexEnd;
      var selection = _selection ? _selection : selectionProps.selection;
      value = value.substring(0, cursorIndexStart) + ('' + markdownLeftOrLR + (selection.length > 0 ? selection : '') + (right ? markdownRight ? markdownRight : markdownLeftOrLR : '')) + value.substring(cursorIndexEnd, value.length);
      _this.props.onChange(value);
      if (selection.length === 0) {
        setTimeout(function () {
          _this.setCaretPosition(cursorIndexStart + markdownRight ? cursorIndexEnd + cursorPosOffset : markdownLeftOrLR.length);
        }, 0);
      }
    };

    _this.handleList = function (e, ordered) {
      e.preventDefault();
      var list = _this.getSelection(_this.props.value).selection.split(/\r?\n/);
      var newList = [];
      for (var i = 0; i < list.length; i++) {
        if (list[i].length > 0) {
          newList.push((ordered ? i + 1 + '.' : '-') + ' ' + list[i]);
        }
      }
      newList = newList.join('\n');
      _this.insertAtCursor(null, '', false, newList);
    };

    _this.handleYoutube = function (e) {
      e.preventDefault();
      var url = prompt('Enter a YouTube URL.');
      var videoId = url.match(/(?:https?:\/{2})?(?:w{3}\.)?youtu(?:be)?\.(?:com|be)(?:\/watch\?v=|\/)([^\s&]+)/);
      if (videoId === null) {
        return;
      }
      _this.insertAtCursor(null, '[![](https://img.youtube.com/vi/' + videoId[1] + '/0.jpg)](https://www.youtube.com/watch?v=' + videoId[1], true, null, ')', 4);
    };

    _this.handleTogglePreview = function (e) {
      e.preventDefault();
      _this.setState({ preview: !_this.state.preview });
    };

    _this.handleTextChange = function (e) {
      _this.props.onChange(e.target.value);
    };

    _this.state = {
      preview: false
    };
    return _this;
  }

  _createClass(MDEditor, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var p = this.props;
      var s = this.state;
      var textAreaStyle = {
        width: '100%',
        outline: '0',
        border: '1px solid #cccccc',
        height: '500px',
        padding: '4px 8px'
      };
      (0, _objectAssign2.default)(textAreaStyle, p.textAreaStyle);
      var buttonStyle = {
        outline: '0',
        border: '1px solid #cccccc',
        margin: '0px 2px',
        padding: '4px 8px',
        cursor: 'pointer',
        justifyContent: 'center',
        alignItems: 'center',
        backgroundColor: '#FFF',
        marginLeft: '4px',
        lineHeight: '1'
      };
      (0, _objectAssign2.default)(buttonStyle, p.buttonStyle);
      var buttonContainerStyle = {
        marginLeft: '-4px',
        marginBottom: '4px'
      };
      (0, _objectAssign2.default)(buttonContainerStyle, p.buttonContainerStyle);
      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          'div',
          { style: buttonContainerStyle },
          _react2.default.createElement(
            'button',
            {
              disabled: this.state.preview,
              style: buttonStyle,
              onClick: function onClick(e) {
                return _this2.insertAtCursor(e, '**', true);
              } },
            _react2.default.createElement('i', { className: 'fa fa-bold' })
          ),
          _react2.default.createElement(
            'button',
            {
              disabled: this.state.preview,
              style: buttonStyle,
              onClick: function onClick(e) {
                return _this2.insertAtCursor(e, '_', true);
              } },
            _react2.default.createElement('i', { className: 'fa fa-italic' })
          ),
          _react2.default.createElement(
            'button',
            {
              disabled: this.state.preview,
              style: buttonStyle,
              onClick: function onClick(e) {
                return _this2.insertAtCursor(e, '### ', false);
              } },
            _react2.default.createElement('i', { className: 'fa fa-header' })
          ),
          _react2.default.createElement(
            'button',
            {
              disabled: this.state.preview,
              style: buttonStyle,
              onClick: function onClick(e) {
                return _this2.handleList(e, false);
              } },
            _react2.default.createElement('i', { className: 'fa fa-list' })
          ),
          _react2.default.createElement(
            'button',
            {
              disabled: this.state.preview,
              style: buttonStyle,
              onClick: function onClick(e) {
                return _this2.handleList(e, true);
              } },
            _react2.default.createElement('i', { className: 'fa fa-list-ol' })
          ),
          p.enableHTML ? _react2.default.createElement(
            'button',
            {
              disabled: this.state.preview,
              style: buttonStyle,
              onClick: function onClick(e) {
                return _this2.insertAtCursor(e, '<blockquote>', true, null, '</blockquote>', 12);
              } },
            _react2.default.createElement('i', { className: 'fa fa-quote-right' })
          ) : null,
          _react2.default.createElement(
            'button',
            {
              disabled: this.state.preview,
              style: buttonStyle,
              onClick: function onClick(e) {
                return _this2.insertAtCursor(e, '```', true, null, '```', 3);
              } },
            _react2.default.createElement('i', { className: 'fa fa-code' })
          ),
          _react2.default.createElement(
            'button',
            {
              disabled: this.state.preview,
              style: buttonStyle,
              onClick: function onClick(e) {
                return _this2.insertAtCursor(e, '[', true, null, ']()', 3);
              } },
            _react2.default.createElement('i', { className: 'fa fa-link' })
          ),
          _react2.default.createElement(
            'button',
            {
              disabled: this.state.preview,
              style: buttonStyle,
              onClick: function onClick(e) {
                return _this2.insertAtCursor(e, '![](', true, null, ')', 4);
              } },
            _react2.default.createElement('i', { className: 'fa fa-file-image-o' })
          ),
          _react2.default.createElement(
            'button',
            {
              disabled: this.state.preview,
              style: buttonStyle,
              onClick: this.handleYoutube },
            _react2.default.createElement('i', { className: 'fa fa-youtube' })
          ),
          _react2.default.createElement(
            'button',
            {
              style: buttonStyle,
              onClick: this.handleTogglePreview },
            _react2.default.createElement('i', { className: 'fa fa-' + (s.preview ? 'pencil' : 'eye') }),
            _react2.default.createElement(
              'span',
              { style: { marginLeft: '6px' } },
              s.preview ? 'Editor' : 'Preview'
            )
          )
        ),
        _react2.default.createElement(
          'div',
          null,
          s.preview ? _react2.default.createElement(_reactMarkdown2.default, {
            source: p.value,
            escapeHtml: !p.enableHTML }) : _react2.default.createElement('textarea', {
            ref: 'text',
            style: textAreaStyle,
            value: p.value,
            onChange: this.handleTextChange,
            placeholder: 'Use Markdown ' + (p.enableHTML ? 'or HTML ' : '') + 'for formatting...' })
        )
      );
    }
  }]);

  return MDEditor;
}(_react2.default.Component);

MDEditor.defaultProps = {
  enableHTML: true,
  textAreaStyle: {},
  buttonStyle: {},
  buttonContainerStyle: {}
};
MDEditor.propTypes = {
  value: _propTypes2.default.string.isRequired,
  enableHTML: _propTypes2.default.bool,
  onChange: _propTypes2.default.func.isRequired,
  textAreaStyle: _propTypes2.default.object,
  buttonStyle: _propTypes2.default.object,
  buttonContainerStyle: _propTypes2.default.object
};
;

window.MDEditor = MDEditor;
exports.default = MDEditor;